#include <d3dx9.h>
#include <stdio.h>
#include <time.h>
#include "dmusic.h"

#pragma comment(lib,"d3d9.lib")
#pragma comment(lib,"d3dx9.lib")
#pragma comment(lib,"dxguid.lib")
#pragma comment(lib,"winmm.lib")

#define MYWNDTITLE		"DX9_Game"
#define MYWNDCLASS		"CLASS_DX9_Game"
#define WIDTH			640 	// ʂ̉̃TCY
#define HEIGHT			480 	// ʂ̏c̃TCY
#define TEX_MAX			256 	// eNX`̍ő吔
#define BRD_MAX			256 	// r{[h̍ő吔
#define BOMB_MAX 		16		// ɕ\ł锚̍ő吔
#define TAMA_NUM		6		// ɕ\ł^}̐
#define PL_NUM			5 		// ̐
#define PL_SIZE			0.4f	// ̑傫
#define G_SIZE			1.5f	// nʂ̑傫
#define M_MAX			50	 	// [V̍ő吔
#define P_MAX			50 		// p[c̍ő吔
#define PI				(float)3.1415926535897932
#define RELEASE(p)		if (p){p->Release();p=NULL;}
#define DELETE2(p)		if (p){delete[] (p);p=NULL;}

struct LVERTEX				// 3DIuWFNg̒_tH[}bg̒`
{
	D3DXVECTOR3	v;			// W
	D3DXVECTOR3	n;			// @xNg
	float		tu,tv;		// eNX`W
};
#define FVF_LVERTEX (D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_TEX1)

struct LVERTEX2				// r{[h̒_tH[}bg̒`
{
	float		x,y,z;
	D3DCOLOR	color;
	float		tu,tv;
};
#define FVF_LVERTEX2 (D3DFVF_XYZ | D3DFVF_DIFFUSE | D3DFVF_TEX1)

typedef struct{
	float cos_x,sin_x,cos_y,sin_y,cos_z,sin_z;
	float move_x,move_y,move_z;
}AXIS,*LPAXIS;

typedef struct{
	D3DXVECTOR3	*pv;			// _̍W
	D3DXVECTOR3	*pn;			// _̖@xNg
	float		*ptu,*ptv;		// _̃eNX`W
	int 		(*pf)[4];		// eʂ̒_ԍB_3̂Ƃ iv[3] = -1B
	int 		t_vtx_ct;		// _
	int 		t_face_ct;		// ʐ
	int 		parts_ct;		// p[c
	int			mt_ct;			// [V̐
}MODEL,*LPMODEL;

typedef struct{
	int 		vtx_ct;			// _
	int 		face_ct;		// ʐ
	D3DXMATRIX	mat[M_MAX];		// ֐߂̕ϊs
}PARTS,*LPPARTS;

typedef struct{
	int 		flag;				//@tO	0:r{[h	1:
	int 		Num;				//@_obt@IuWFNg̔ԍ
	float		x;					//@X W
	float		y;					//@Y W
	float		z;					//@Z W
	float		roll;				//@]px
	int 		texture;			//@eNX`IuWFNgԍ
}BOARD_SORT;

BOARD_SORT	g_brd_sort[BRD_MAX];	//@r{[h̃f[^ꎞێ
BOARD_SORT	g_bomb_data[BOMB_MAX]; 	//@̃f[^ꎞێ

MODEL	g_m1[2];					// f̏
LPPARTS	g_pp1[2];					// f̊ep[c̏

int		g_mt_idx[2] = {0,0};		// ݑIĂ郂[V̔ԍi0:@A1:G@j
int		g_status[2] = {0,0};		// {bg̏ԁi0:A1:A2:A3:|A4:A5:eji0:@A1:G@j
int		g_mt_ct[2][4] = {{0,0,24,0},{0,0,24,0}};// {bg̃[VJEgi0:1:|A2:A3:eji0:@A1:G@j
float	g_life[2] = {100,100};		// {bǧ݂̐_i0:@A1:G@j
float	g_pos_x[2] = {-0.5f,0.5f};	// {bgXWi0:@A1:G@j
float	g_pos_z[2] = {0.0f,0.0f};	// {bgZWi0:@A1:G@j
float	g_vec_x[2] = {0.0f,0.0f};	// {bg̃xNgXi0:@A1:G@j
float	g_vec_z[2] = {0.0f,0.0f};	// {bg̃xNgZi0:@A1:G@j
float	g_roll[2] = {90,270};		// {bg̉]px (x)i0:@A1:G@j
float	g_look_x = 0.0f;			// _ X W
float	g_look_y = 0.0f;			// _ Y W
float	g_look_z = 0.0f;			// _ Z W
int 	g_brd_ct = 0;				// r{[h̃f[^Zbgꂽ
int 	g_bomb_flag[BOMB_MAX];		// ̂nmƂnee
int 	*g_order; 					// r{[h̕\
bool	g_flag_PressBttn[4] = {0,0,0,0};// Rg[̃{^PĂtOi0:{^P,1:{^Q,2:{^R,3:{^Sj
int		g_flag_PressX = 15;			// Rg[̉̃L[ĂtOiF<15,EF>15j
int		g_flag_PressY = 15;			// Rg[̏c̃L[ĂtOiF<15,F>15j
bool	g_flag_throwEnemy[TAMA_NUM];// ếi0:@A1:G@j
float	g_ball_x[TAMA_NUM];			// ëʒu
float	g_ball_z[TAMA_NUM];
float	g_ball_vec_x[TAMA_NUM];		// e̕
float	g_ball_vec_z[TAMA_NUM];
int		g_ball_ct[TAMA_NUM];		// ěoߎ
float	g_vecEM_x = 0,g_vecEM_z = 0;// G@玩@ւ̃xNg
float	g_lenEM = 0;				// G@Ǝ@̋
bool	g_flagTitle = 1;			// ^Cg\tOi0:\A1:\j
int		g_title_ct = 0;				// Ԃv

// ̈ʒu
float g_pillar_x[5] = {0.0f,0.7f,-0.7f,-0.7f, 0.7f};
float g_pillar_y[5] = {0.0f,0.0f, 0.0f, 0.0f, 0.0f};
float g_pillar_z[5] = {0.0f,0.7f,-0.7f, 0.7f,-0.7f};
// [V
int		g_mt_walk[]		= {0,1,2,5,4,3};
int		g_mt3[]			= {5,4,3,0,1,2};
int		g_mt_down[]		= {11,15,16,15,12,13,14,13,12,15,16,15,12,12,17,18,19,20,21};
float	g_mt_down_y[]	= {0.04f,0.08f,0.11f,0.13f,0.14f,0.13f,0.1f,0.08f,0.07f,0.09f,0.11f,0.13f,0.14f,0.14f,0,0,0,0,0};
int		g_mt_damage[]	= {7,8,9,10,6};
int		g_mt_gun[]		= {6,32,33,34,35,36,33,32,6};
int		g_mt_barrier[]	= {22,23,22,6};

LPDIRECT3D9 			g_pD3D = NULL;		// Direct3DIuWFNg
LPDIRECT3DDEVICE9		g_pD3DDev = NULL;	// foCXIuWFNg
D3DPRESENT_PARAMETERS   g_d3dpp;			// obNobt@̃p[^
LPDIRECT3DTEXTURE9		g_pTex[TEX_MAX];	// eNX`
LPDIRECT3DVERTEXBUFFER9 g_pVB[BRD_MAX];		// r{[h
LPD3DXSPRITE			g_pSpr = NULL;		// XvCg
LPD3DXFONT				g_pFont = NULL;		// ̕`
LPD3DXMESH				g_pMeshText = NULL;	// 3DbV

HINSTANCE	g_hInst = NULL; 				// CX^Xnh
HWND		g_hWnd	= NULL; 				// EBhẼnh

// ֐̃vg^Cv錾
int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrevInst, LPSTR lpCmdLine, int nCmdShow);
LRESULT	CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
void	Ope_Menu();
bool	Init_DMusic8();
HRESULT InitD3D(HWND hWnd);
void	Create_Object();
void	InitGeometry();
void	Load_Texture(int Num,char *fn);
void	Set_Light();
void	Set_Material(float alpha,float red,float green,float blue,float power);
void	Draw_Main();
void	Draw_Robot(bool flagEnemy);
void	Action_Enemy();
void	Draw_Model(bool flagEnemy, int idx, float x, float y, float z);
void	Set_Matrix(int idx, int p_idx, int m_idx, float *val);
void	SetLVertex2(LVERTEX2 *v,float x,float y,float z,D3DCOLOR color,float tu,float tv);
void	Load_Board(int Num,float x0,float x1,float y0,float y1,float z0,float z1);
void	Set_Board(int Num,float x,float y,float z,int tx_n);
void	Draw_Board(int Num,float x,float y,float z,int tx_n);
void	Draw_Rect(int Num,float x,float y,float z,float roll,int tx_n);
void	Set_Bomb(float x,float y,float z);
void	Set_Bomb2(int Num,float x,float y,float z);
void	Draw_All();
void	Sort();
void	Draw_Bomb(int Num,float x,float y,float z);
void	Draw_LifeGage();
void	Draw_GameOver();
void	Create_3DTextMesh();
void	Draw_Title();
void	Return_Title();
D3DXVECTOR3	Enemy_SoundPos();
void	Get_Key();
void	Left();
void	Up(bool flagEnemy, float speed);
void	Right();
void	Down(bool flagEnemy, float speed);
void	Mt_Walk(bool flagEnemy);
void	Mt_Damage(bool flagEnemy);
void	Mt_Down(bool flagEnemy);
void	Mt_Sord(bool flagEnemy);
void	Mt_Gun(bool flagEnemy);
void	Key_Z();
void	Key_X();
void	Key_C();
void	Throw_Ball(bool flagEnemy);
void	Set_Ball();
int		RandTo(int max);
void	Init_Global();
void	Init_File(int idx);
bool	Load_File_BDT(int idx, char *filename);
void	Cleanup();

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrevInst, LPSTR lpCmdLine, int nCmdShow)
{
	WNDCLASSEX wc;
	
	g_hInst = hInst;
	
	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX); 
	wc.lpfnWndProc		= (WNDPROC)WndProc;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(hInst,IDI_WINLOGO);
	wc.hCursor			= LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
	wc.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.lpszClassName	= MYWNDCLASS;
	if(RegisterClassEx(&wc) == 0)
		return 0;
	
	g_hWnd = CreateWindowEx(0, 
				MYWNDCLASS,
				MYWNDTITLE,
				WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX | WS_VISIBLE,
				CW_USEDEFAULT, CW_USEDEFAULT, WIDTH, HEIGHT,
				NULL,
				NULL,
				hInst,
				NULL);

	if(g_hWnd == NULL)
		return 0;
	
	MSG msg;
	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}// WinMain

// EBhE vV[W
LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_CREATE:
		if(FAILED( InitD3D(hWnd) )){
			MessageBox(hWnd,"D3D9̏Ɏs܂",MYWNDTITLE,MB_ICONEXCLAMATION);
			SendMessage(hWnd,WM_CLOSE,0,0);
			return 0;
		}
		if(joyGetNumDevs()){		// Q[Rg[ foCX̌o
			joySetCapture(hWnd, JOYSTICKID1, 0, FALSE);	// Lv`Jn
		}
		srand( (unsigned)time(NULL));
		Init_Global();				// Oϐ̏
		Init_DMusic8();
		SetTimer(hWnd,1,110,NULL);
		break;
		
	case MM_JOY1BUTTONDOWN:			// Rg[P̃{^ꂽ
		if(wParam & JOY_BUTTON1CHG)
			g_flag_PressBttn[0] = true;
		else if(wParam & JOY_BUTTON2CHG)
			g_flag_PressBttn[1] = true;
		else if(wParam & JOY_BUTTON3CHG)
			g_flag_PressBttn[2] = true;
		else if(wParam & JOY_BUTTON4CHG)
			g_flag_PressBttn[3] = true;
		break;
		
	case MM_JOY1BUTTONUP:			// Rg[P̃{^ꂽ
		if(wParam & JOY_BUTTON1CHG)
			g_flag_PressBttn[0] = false;
		else if(wParam & JOY_BUTTON2CHG)
			g_flag_PressBttn[1] = false;
		else if(wParam & JOY_BUTTON3CHG)
			g_flag_PressBttn[2] = false;
		else if(wParam & JOY_BUTTON4CHG){
			g_flag_PressBttn[3] = false;
			Ope_Menu();
		}
		break;
		
	case MM_JOY1MOVE:				// Rg[P̕L[ꂽ
		g_flag_PressX = LOWORD(lParam) >> 11;
		g_flag_PressY = HIWORD(lParam) >> 11;
		break;
		
	case WM_TIMER:
		if(g_flagTitle){
			Draw_Title();			// ^Cg\
		}
		else{
			Get_Key();				// L[͂̎擾
			Draw_Main();			// IuWFNg̕`
			Return_Title();			// ^Cg֖߂
		}
		break;
		
	case WM_LBUTTONDOWN:
		Ope_Menu();
		break;
		
	case WM_KEYDOWN:
		switch (wParam)
		{
		case VK_ESCAPE: 			// [ESC] L[ƏI
			SendMessage(hWnd,WM_CLOSE,0,0);
			break;
		case VK_SPACE:
			Ope_Menu();
			break;
		}
		break;
		
	case WM_CLOSE:
		KillTimer(hWnd,1);
		DestroyWindow(hWnd);
		Cleanup();					// Direct3D C^[tF[X
		PostQuitMessage(0);
		break;

	default:
		return DefWindowProc(hWnd, uMsg, wParam, lParam);
	}
	return 0;
}// WndProc

// Q[JnA^Cgʂɖ߂
void Ope_Menu()
{
	if(g_flagTitle){
		g_flagTitle = 0;
		PlayBGM();
	}
	if(g_status[0] == 3 || g_status[1] == 3){
		Init_Global();
		StopBGM();
	}
}// Ope_Menu

// DMusic8̏
bool Init_DMusic8()
{
	if(!Music_Init()){	// DirectMusic
		return 0;
	}
	LoadBGM_F("wav\\fgsaio20.mid",-7);
	LoadSND_3D_F(0,"wav\\bomb.wav",0);
	LoadSND_3D_F(1,"wav\\laser.wav",0);
	LoadSND_3D_F(2,"wav\\rbt_dwn.wav",0);
	LoadSND_3D_F(3,"wav\\sword.wav",0);
	LoadSND_3D_F(4,"wav\\walk.wav",0);
	return 1;
}// Init_DMusic8

// D3D9̏
HRESULT InitD3D(HWND hWnd)
{
	// Direct3D9 쐬
	g_pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	if (!g_pD3D){
		return E_FAIL;
	}
	
	ZeroMemory(&g_d3dpp, sizeof(D3DPRESENT_PARAMETERS));
	g_d3dpp.Windowed = TRUE;
	g_d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
	g_d3dpp.BackBufferFormat = D3DFMT_UNKNOWN;
	g_d3dpp.EnableAutoDepthStencil = TRUE;
	g_d3dpp.AutoDepthStencilFormat = D3DFMT_D16;
	
	// D3D9Device 쐬
	if(FAILED(g_pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
									  D3DCREATE_SOFTWARE_VERTEXPROCESSING,
									  &g_d3dpp, &g_pD3DDev))){
		if( FAILED(g_pD3D->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_REF, hWnd,
									  D3DCREATE_SOFTWARE_VERTEXPROCESSING,
									  &g_d3dpp, &g_pD3DDev))){
			return E_FAIL;
		}
	}
	
	Create_Object();
	InitGeometry();
	
	return S_OK;
}// InitD3D

// Jn݂̂̐ݒ
void Create_Object()
{
	// ̓ǂݍ
	if(!(Load_File_BDT(0,"bdt\\pillar.bdt"))){
		MessageBox(0,"t@C̓ǂݍ݂Ɏs܂",MYWNDTITLE,0);
	}
	// {bg̓ǂݍ
	if(!(Load_File_BDT(1,"bdt\\robot1.bdt"))){
		MessageBox(0,"t@C̓ǂݍ݂Ɏs܂",MYWNDTITLE,0);
	}
	
	// 3DeLXgbV̍쐬
	Create_3DTextMesh();
	
	// nʂ̍쐬
	Load_Board(0,-G_SIZE,G_SIZE,0.0f,0.0f,-G_SIZE,G_SIZE);
	// ^}̍쐬
	Load_Board(2,-0.035f,0.035f,0.035f,-0.035f,-0.0f,-0.0f);
	
	//eNX`̓ǂݍ
	Load_Texture(0,"image\\floor1.png");
	Load_Texture(1,"image\\title.png");
	Load_Texture(2,"image\\bomb1.png");
	Load_Texture(3,"image\\bomb2.png");
	Load_Texture(4,"image\\bomb3.png");
	Load_Texture(5,"image\\beem1.png");
	Load_Texture(6,"image\\beem2.png");
	Load_Texture(7,"image\\floor2.png");
	Load_Texture(8,"image\\robot1.jpg");
	Load_Texture(9,"image\\grn_hp1.png");
	Load_Texture(10,"image\\grn_hp2.png");
	Load_Texture(11,"image\\red_hp1.png");
	Load_Texture(12,"image\\red_hp2.png");
	Load_Texture(13,"image\\black.png");
	Load_Texture(14,"image\\sword1.png");
	Load_Texture(15,"image\\gray.png");
	
	// XvCg̍쐬
	D3DXCreateSprite(g_pD3DDev, &g_pSpr);
	
	// tHg̍쐬
	LOGFONT	lf;
	HFONT	hFont;
	ZeroMemory(&lf, sizeof(lf));
	lf.lfPitchAndFamily = FIXED_PITCH;
	lf.lfCharSet = SHIFTJIS_CHARSET;
	lf.lfWeight = FW_BOLD;
	hFont = CreateFontIndirect(&lf);
	D3DXCreateFont(g_pD3DDev, hFont, &g_pFont);
}// Create_Object

// ݒ̏
void InitGeometry()
{
	g_pD3DDev->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);
	g_pD3DDev->SetRenderState(D3DRS_ZENABLE,  TRUE);
	g_pD3DDev->SetRenderState(D3DRS_LIGHTING, FALSE);
	g_pD3DDev->SetSamplerState(0,D3DSAMP_MINFILTER,D3DTEXF_LINEAR);
	g_pD3DDev->SetSamplerState(0,D3DSAMP_MAGFILTER,D3DTEXF_LINEAR);
	g_pD3DDev->SetRenderState(D3DRS_ALPHABLENDENABLE,TRUE);
	g_pD3DDev->SetRenderState(D3DRS_SRCBLEND,D3DBLEND_SRCALPHA);
	g_pD3DDev->SetRenderState(D3DRS_DESTBLEND,D3DBLEND_INVSRCALPHA);
	g_pD3DDev->SetVertexShader(NULL);
	
	// vWFNVs
	D3DXMATRIX matProj;
	D3DXMatrixPerspectiveFovLH(&matProj,60.0f*PI/180.0f,(float)WIDTH/HEIGHT,0.01f,10.0f);
	g_pD3DDev->SetTransform(D3DTS_PROJECTION,&matProj);
	
	// foCX̏
	if(g_pSpr){
		g_pSpr->OnLostDevice();
		g_pSpr->OnResetDevice();
	}
	if(g_pFont){
		g_pFont->OnLostDevice();
		g_pFont->OnResetDevice();
	}
	
	// Cg̐ݒ
	Set_Light();
	// }eA̐ݒ
	Set_Material(1.0f,0.8f,0.8f,0.8f,20.0f);
}// InitGeometry

// eNX`t@Cǂݍ
// NumFeNX`̔ԍ (0 ` TEX_MAX-1)
// fnFt@C
void Load_Texture(int Num,char *fn)
{
	D3DXCreateTextureFromFileEx(g_pD3DDev,fn,0,0,0,0,D3DFMT_UNKNOWN,D3DPOOL_MANAGED,D3DX_FILTER_LINEAR,D3DX_FILTER_LINEAR,0xff000000,NULL,NULL,&g_pTex[Num]);
}// Load_Texture

// Ɩݒ
void Set_Light()
{
	D3DXVECTOR3 vecDir;
	D3DLIGHT9	light;
	
	ZeroMemory( &light, sizeof(D3DLIGHT9) );
	light.Type		= D3DLIGHT_DIRECTIONAL;
	light.Diffuse.r = light.Specular.r = 1.0f;
	light.Diffuse.g = light.Specular.g = 1.0f;
	light.Diffuse.b = light.Specular.b = 1.0f;
	vecDir = D3DXVECTOR3(0.866025f,-0.5f,0.5f);
	D3DXVec3Normalize((D3DXVECTOR3*)&light.Direction, &vecDir);
	
	g_pD3DDev->SetLight(0, &light);
	g_pD3DDev->LightEnable(0, TRUE);
	g_pD3DDev->SetRenderState(D3DRS_AMBIENT, 0x00404040);
	g_pD3DDev->SetRenderState(D3DRS_SPECULARENABLE, TRUE);
	g_pD3DDev->SetRenderState(D3DRS_SPECULARMATERIALSOURCE, D3DMCS_MATERIAL);
}// Set_Light

// }eA̐ݒ
void Set_Material(float alpha,float red,float green,float blue,float power)
{
	D3DMATERIAL9 mtrl;
	
	ZeroMemory(&mtrl, sizeof(D3DMATERIAL9));
	mtrl.Diffuse.a = mtrl.Ambient.a = alpha;
	mtrl.Diffuse.r = mtrl.Ambient.r = red;
	mtrl.Diffuse.g = mtrl.Ambient.g = green;
	mtrl.Diffuse.b = mtrl.Ambient.b = blue;
	mtrl.Specular.a = 1.0f;
	mtrl.Specular.r = 1.0f;
	mtrl.Specular.g = 1.0f;
	mtrl.Specular.b = 1.0f;
	mtrl.Power = 20.0f;
	// }eAKp
	g_pD3DDev->SetMaterial(&mtrl);
}// Set_Material

// `
void Draw_Main()
{
	int		i,j;
	float	target_x,target_y,target_z;
	
	g_pD3DDev->Clear(0,NULL,D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER,D3DCOLOR_XRGB(0,0,0),1.0f,0);
	if(SUCCEEDED(g_pD3DDev->BeginScene()))
	{
		for(i=0;i<2;i++){
			g_vec_x[i] = (float)sin(g_roll[i]/180*PI);
			g_vec_z[i] = (float)cos(g_roll[i]/180*PI);
		}
		
		// r[s̐ݒ
		D3DXMATRIX matView;
		
		static float fin_roll = 0,fin_y = 0;
		
		if(g_status[1] == 3){
			if(fin_roll > -165){
				fin_roll -= 3;
				fin_y += 0.003f;
			}
			g_look_x = -(float)sin((g_roll[0]+fin_roll)/180*PI) * 0.3f + g_pos_x[0];
			g_look_y = 0.22f + fin_y;
			g_look_z = -(float)cos((g_roll[0]+fin_roll)/180*PI) * 0.3f + g_pos_z[0];
		}
		else{
			g_look_x = -g_vec_x[0] * 0.3f + g_pos_x[0];
			g_look_y = 0.22f;
			g_look_z = -g_vec_z[0] * 0.3f + g_pos_z[0];
			if(fin_roll)
				fin_roll = 0;
			if(fin_y)
				fin_y = 0;
		}
		target_x = g_pos_x[0];
		target_y = 0.1f;
		target_z = g_pos_z[0];
		D3DXMatrixLookAtLH(&matView,&D3DXVECTOR3(g_look_x,g_look_y,g_look_z),&D3DXVECTOR3(target_x,target_y,target_z),&D3DXVECTOR3(0,1,0));
		g_pD3DDev->SetTransform(D3DTS_VIEW,&matView);
		
		// G@玩@ւ̒PʃxNgƋ
		g_vecEM_x = g_pos_x[0] - g_pos_x[1];
		g_vecEM_z = g_pos_z[0] - g_pos_z[1];
		g_lenEM   = D3DXVec2Length(&D3DXVECTOR2(g_vecEM_x, g_vecEM_z));
		g_vecEM_x /= g_lenEM;
		g_vecEM_z /= g_lenEM;
		
		// G@̍s
		Action_Enemy();
		
		// nʂ̕`
		Draw_Rect(0,0.0f,0.0f,0.0f,0.0f,0);
		// ̕`
		for(i=0;i<PL_NUM;i++){
			Draw_Model(0, 0, g_pillar_x[i], g_pillar_y[i], g_pillar_z[i]);
		}
		
		// Ƃi̕`揀j
		// U\px߂
		float angle1,angle2;
		D3DXVECTOR2 v1(-g_vecEM_x,-g_vecEM_z),v2(g_vec_x[0],g_vec_z[0]);
		D3DXVECTOR2 v3(g_vecEM_x,g_vecEM_z),v4(g_vec_x[1],g_vec_z[1]);
		angle1 = (float) acos(D3DXVec2Dot(&v1, &v2)) * 180 / PI;
		angle2 = (float) acos(D3DXVec2Dot(&v3, &v4)) * 180 / PI;
		// G@ɌƂ
		if(g_lenEM < 0.18f && g_mt_idx[0] == 28 && angle1 < 45 && g_status[1] != 3){
			Set_Bomb(g_pos_x[1]+g_vecEM_x*0.05f,0.18f,g_pos_z[1]+g_vecEM_z*0.05f);
			g_status[1] = 2;
			g_life[1] -= 7;
			D3DXVECTOR3 e_snd = Enemy_SoundPos();
			PlaySND_3D(0,e_snd.x,e_snd.z);
		}
		// @ɌƂ
		if(g_lenEM < 0.18f && g_mt_idx[1] == 28 && angle2 < 45 && g_status[0] != 3){
			Set_Bomb(g_pos_x[0]-g_vec_x[0]*0.08f,0.18f,g_pos_z[0]-g_vec_z[0]*0.08f);
			g_status[0] = 2;
			g_life[0] -= 7;
			PlaySND_3D(0,0,0);
		}
		
		// ^}Ƃi̕`揀j
		bool flagHit;
		for(i=0;i<TAMA_NUM;i++){
			if(g_ball_ct[i] != 0){
				flagHit = false;
				// Ƀ^}Ƃ
				for(j=0;j<PL_NUM;j++){
					if(D3DXVec2Length(&D3DXVECTOR2(g_pillar_x[j]-g_ball_x[i],
													g_pillar_z[j]-g_ball_z[i])) < PL_SIZE * 0.6f)
					{
						Set_Bomb(g_ball_x[i]-g_ball_vec_x[i]*0.1f,0.18f,g_ball_z[i]-g_ball_vec_z[i]*0.1f);
						D3DXMATRIX mat;
						D3DXVECTOR3 vs2(g_pillar_x[j]-g_pos_x[0], 0, g_pillar_z[j]-g_pos_z[0]), snd;
						D3DXMatrixRotationY(&mat, -g_roll[0]*PI/180);
						D3DXVec3TransformCoord(&snd, &vs2, &mat);
						PlaySND_3D(0,snd.x,snd.z);
						flagHit = true;
					}
				}
				// G@Ƀ^}Ƃ
				if(D3DXVec2Length(&D3DXVECTOR2(g_pos_x[1]-g_ball_x[i],g_pos_z[1]-g_ball_z[i])) < 0.08f && !g_flag_throwEnemy[i] && g_status[1] != 3){
					Set_Bomb(g_ball_x[i]+g_vecEM_x*0.1f,0.18f,g_ball_z[i]+g_vecEM_z*0.1f);
					g_status[1] = 2;
					g_life[1] -= 4;
					D3DXVECTOR3 e_snd = Enemy_SoundPos();
					PlaySND_3D(0,e_snd.x,e_snd.z);
					flagHit = true;
				}
				// @Ƀ^}Ƃ
				if(D3DXVec2Length(&D3DXVECTOR2(g_pos_x[0]-g_ball_x[i],g_pos_z[0]-g_ball_z[i])) < 0.08f && g_flag_throwEnemy[i] && g_status[0] != 3){
					Set_Bomb(g_pos_x[0]-g_vec_x[0]*0.08f,0.18f,g_pos_z[0]-g_vec_z[0]*0.08f);
					g_status[0] = 2;
					g_life[0] -= 4;
					PlaySND_3D(0,0,0);
					flagHit = true;
				}
				if(flagHit){
					g_ball_ct[i] = 0;
					g_ball_x[i] = G_SIZE + 1;
					g_ball_z[i] = G_SIZE + 1;
				}
			}
		}
		
		// e̕`揀
		Set_Ball();
		// G@̕`
		Draw_Robot(1);
		// @̕`
		Draw_Robot(0);
		// Q[I[o[̕\
		Draw_GameOver();
		// r{[h̕`
		Draw_All();
		// CtQ[W̕`
		Draw_LifeGage();
		
		g_pD3DDev->EndScene();
		g_pD3DDev->SetTexture(0, NULL);
	}
	g_pD3DDev->Present(NULL,NULL,NULL,NULL);
	
	if(g_pD3DDev->TestCooperativeLevel() == D3DERR_DEVICENOTRESET){
		g_pD3DDev->Reset(&g_d3dpp);
		InitGeometry();
		Draw_Main();
	}
}// Draw_Main

// {bg̕`
// flagEnemy: 0:@, 1:G@
void Draw_Robot(bool flagEnemy)
{
	float dy = 0;
	if(g_status[flagEnemy] == 3){
		Mt_Down(flagEnemy);
		dy = g_mt_down_y[g_mt_ct[flagEnemy][1]];
	}
	else{
		if(g_status[flagEnemy] == 0)
			g_mt_idx[flagEnemy] = 6;
		else if(g_status[flagEnemy] == 1)
			Mt_Walk(flagEnemy);
		else if(g_status[flagEnemy] == 2)
			Mt_Damage(flagEnemy);
		else if(g_status[flagEnemy] == 4)
			Mt_Sord(flagEnemy);
		else if(g_status[flagEnemy] == 5)
			Mt_Gun(flagEnemy);
	}
	Draw_Model(flagEnemy, 1, g_pos_x[flagEnemy], 0.17f-dy, g_pos_z[flagEnemy]);
}// Draw_Robot

// G@̍s
void Action_Enemy()
{
	if(g_status[0] == 3 || g_status[1] == 3){
		return;
	}
	
	int i;
	// U\px߂
	float angle1,angle2,angle3;
	D3DXVECTOR2 v1(g_vecEM_x,g_vecEM_z),v2(g_vec_x[1],g_vec_z[1]);
	angle1 = (float) acos(D3DXVec2Dot(&v1, &v2)) * 180 / PI;
	// G@Ǝ@̊ԂɏQꍇ͌Ȃ
	bool flagGun1 = 0;
	for(i=0;i<PL_NUM;i++){
		float len = D3DXVec2Length(&D3DXVECTOR2(g_pillar_x[i]-g_pos_x[1], g_pillar_z[i]-g_pos_z[1]));
		if(len < 0.9f){
			D3DXVECTOR2 v1(g_pillar_x[i]-g_pos_x[1], g_pillar_z[i]-g_pos_z[1]),v2(g_vecEM_x,g_vecEM_z);
			angle2 = (float) acos(D3DXVec2Dot(&v1, &v2)) * 180 / PI;
			angle3 = 30 / len;
			if(angle2 < angle3){
				flagGun1 = true;
				break;
			}
		}
	}
	// Ԑݒi0:A1:A2:A3:|A4:A5:ej
	if(g_status[1] != 2){
		if(angle1 < 25 && g_lenEM < 0.2f){
			if(g_status[1] != 4 && !RandTo(3)){	// 3Ɉx
				g_status[1] = 4;
				g_mt_ct[1][3] = 0;
			}
		}
		else if(angle1 < 12 && !flagGun1){
			if(g_status[1] != 5 && !RandTo(3)){	// e3Ɉx
				g_status[1] = 5;
				g_mt_ct[1][2] = 24;
			}
		}
		else if(g_status[1] == 0){
			g_status[1] = 1;
		}
	}
	
	// G@玩@ւ̊px
	float rollEM = (float)atan2(g_vecEM_x, g_vecEM_z) * 180 / PI;
	if(rollEM < 0)
		rollEM += 360;
	else if(rollEM >= 360)
		rollEM -= 360;
	
	float	vecEP_x,vecEP_z;	// G@Qւ̃xNg
	float	lenEP;				// G@ƏQ̋
	bool	flagPL = false;		// QɂԂƂ
	static int	pre_roll = 0;	// Q̒xoA0ɐݒ肷
	
	for(i=0;i<PL_NUM;i++){
		vecEP_x = g_pillar_x[i] - g_pos_x[1];
		vecEP_z = g_pillar_z[i] - g_pos_z[1];
		lenEP   = D3DXVec2Length(&D3DXVECTOR2(vecEP_x, vecEP_z));
		vecEP_x /= lenEP;
		vecEP_z /= lenEP;
		// QɂԂƂ
		if(lenEP <= PL_SIZE){
			// Q̓ł͉荞ޕύXłȂ
			if(pre_roll != 0){
				g_roll[1] += pre_roll;
				if(g_roll[1] < 0)			g_roll[1] += 360;
				else if(g_roll[1] >= 360)	g_roll[1] -= 360;
				flagPL = true;
				break;
			}
			// iG@QjƁiG@@j̐px݊p̂Ƃ͉I񂵂Ȃ
			float angle4 = (float) acos(D3DXVec2Dot(&v1, &D3DXVECTOR2(vecEP_x,vecEP_z))) * 180 / PI;
			if(angle4 > 90){
				flagPL = false;
				break;
			}
			// G@͏Q̍Êǂɂ邩H
			float cross_z = vecEM_x * vecEP_z - vecEM_z * vecEP_x;	// OςZ
			// G@]
			if(cross_z >= 0.0f){
				g_roll[1] += 2;
				if(g_roll[1] < 0)
					g_roll[1] += 360;
				pre_roll = 2;
			}
			else{
				g_roll[1] -= 2;
				if(g_roll[1] >= 360)
					g_roll[1] -= 360;
				pre_roll = -2;
			}
			flagPL = true;
			break;
		}
	}
	if(!flagPL){
		pre_roll = 0;
	}
	
	// 덷 }10x͈͓̔œG@@ɌĂƂOiAȊO͕]
	if(fabs(rollEM - g_roll[1]) < 10 || flagPL){
		// Oi
		float speed = 0.010f;
		if(flagPL)
			speed = 0.004f;
		else if(g_status[1] != 1)
			speed = 0.0005f;
		g_pos_x[1] += speed * g_vec_x[1];
		g_pos_z[1] += speed * g_vec_z[1];
	}
	else if(!flagPL){
		float fDif = rollEM - g_roll[1];
		if((fDif >= 0 && fDif < 180) || fDif < -180){
			g_roll[1] += 5;
			if(g_roll[1] >= 360)
				g_roll[1] -= 360;
		}
		else{
			g_roll[1] -= 5;
			if(g_roll[1] < 0)
				g_roll[1] += 360;
		}
	}
	// @ƂԂƂ
	if(g_lenEM < 0.13f){
		g_pos_x[1] -= 0.02f * (float)sin(rollEM/180*PI);
		g_pos_z[1] -= 0.02f * (float)cos(rollEM/180*PI);
		// nʂ̒[ɓBƂ
		if(g_pos_x[1] < -G_SIZE || g_pos_x[1] > G_SIZE)
			g_pos_x[1] -= 0.02f * g_vec_x[1];
		if(g_pos_z[1] < -G_SIZE || g_pos_z[1] > G_SIZE)
			g_pos_z[1] -= 0.02f * g_vec_z[1];
	}
}// Action_Enemy

// f̕`
// flagEnemy: 0:@, 1:G@
// idx      : bV̔ԍ
// x,y,z    : SW
void Draw_Model(bool flagEnemy, int idx, float x, float y, float z)
{
	int 		i,j,k,idx2,f_n;
	LVERTEX		lv[4];
	D3DXMATRIX	matWorld,matT,matRY;
	
	g_pD3DDev->SetFVF(FVF_LVERTEX);	// _tH[}bg̐ݒ
	g_pD3DDev->SetRenderState(D3DRS_LIGHTING, TRUE);
	// eNX`̃bv
	g_pD3DDev->SetRenderState(D3DRS_WRAP0, D3DWRAPCOORD_0);
	// eNX`Kp
	if(idx == 0)
		g_pD3DDev->SetTexture(0, g_pTex[7]);
	else
		g_pD3DDev->SetTexture(0, g_pTex[8]);
	if(flagEnemy)
		Set_Material(1.0f,0.5f,0.5f,1.0f,20.0f);
	D3DXMatrixTranslation(&matT,x,y,z);
	D3DXMatrixRotationY(&matRY,g_roll[flagEnemy]/180*PI);
	
	for(k=0;k<g_m1[idx].parts_ct;k++){
		if(g_m1[idx].mt_ct){
			matWorld = g_pp1[idx][k].mat[g_mt_idx[flagEnemy]] * matRY * matT;
		}
		else{
			matWorld = matT;
		}
		g_pD3DDev->SetTransform(D3DTS_WORLD,&matWorld);	// _W̍sϊ
		if(idx != 0 && k == 43){
			g_pD3DDev->SetRenderState(D3DRS_SRCBLEND,D3DBLEND_ONE);
			g_pD3DDev->SetRenderState(D3DRS_DESTBLEND,D3DBLEND_ONE);
			if(g_status[flagEnemy] == 4){
				Set_Material(0.5f,1.0f,1.0f,1.0f,20.0f);
				g_pD3DDev->SetTexture(0, g_pTex[14]);
			}
			else{
				continue;
			}
		}
		for(i=g_pp1[idx][k].face_ct;i<g_pp1[idx][k+1].face_ct;i++){
			for(j=0;j<4;j++){
				if(j != 3 || g_m1[idx].pf[i][3] != -1){
					idx2 = g_pp1[idx][k].vtx_ct + g_m1[idx].pf[i][j];
					lv[j].v  = g_m1[idx].pv[idx2];
					lv[j].n  = g_m1[idx].pn[idx2];
					lv[j].tu = g_m1[idx].ptu[idx2];
					lv[j].tv = g_m1[idx].ptv[idx2];
				}
			}
			f_n = 2;
			if(g_m1[idx].pf[i][3] == -1)
				f_n = 1;
			g_pD3DDev->DrawPrimitiveUP(D3DPT_TRIANGLEFAN,f_n,lv,sizeof(LVERTEX));
		}
	}
	g_pD3DDev->SetRenderState(D3DRS_LIGHTING, FALSE);
	g_pD3DDev->SetRenderState(D3DRS_WRAP0, 0);
	g_pD3DDev->SetRenderState(D3DRS_SRCBLEND,D3DBLEND_SRCALPHA);
	g_pD3DDev->SetRenderState(D3DRS_DESTBLEND,D3DBLEND_INVSRCALPHA);
	Set_Material(1.0f,1.0f,1.0f,1.0f,20.0f);
	// eNX`W̃XP[O
	if(1){
		g_pD3DDev->SetTextureStageState(0, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_DISABLE);
	}
}// Draw_Model

// ֐߂̕ϊs쐬
void Set_Matrix(int idx, int p_idx, int m_idx, float *val)
{
	D3DXMATRIX	matT,matRX,matRY,matRZ;
	
	D3DXMatrixIdentity(&matRX);
	D3DXMatrixIdentity(&matRY);
	D3DXMatrixIdentity(&matRZ);
	D3DXMatrixIdentity(&matT);
	
	matRX._22 =  val[0];
	matRX._23 =  val[1];
	matRX._32 = -val[1];
	matRX._33 =  val[0];
	matRY._11 =  val[2];
	matRY._13 =  val[3];
	matRY._31 = -val[3];
	matRY._33 =  val[2];
	matRZ._11 =  val[4];
	matRZ._12 =  val[5];
	matRZ._21 = -val[5];
	matRZ._22 =  val[4];
	matT._41  = -val[6];
	matT._42  = -val[7];
	matT._43  = -val[8];
	
	g_pp1[idx][p_idx].mat[m_idx] = matRX * matRY * matRZ * matT;
}// Set_Matrix

void SetLVertex2(LVERTEX2 *v,float x,float y,float z,D3DCOLOR color,float tu,float tv)
{
	v->x = x;
	v->y = y;
	v->z = z;
	v->color = color;
	v->tu = tu;
	v->tv = tv;
}// SetLVertex2

// `(r{[hȂ)̒_obt@쐬
// Num: g_pVB[] ̔ԍ (0 ` BOMB_MAX-1)
// x0 : `̍̍W
// x1 : `̉E̍W
// y0 : `̏̍W
// y1 : `̉̍W
// z0 : `̑O̍W
// z1 : `̌̍W
// y  z ̂ǂ炩́AB
void Load_Board(int Num,float x0,float x1,float y0,float y1,float z0,float z1)
{
	LVERTEX2 v1[4],*v2;
	D3DCOLOR color = D3DCOLOR_RGBA(255,255,255,255);

	SetLVertex2(&v1[0],x0,y0,z1,color,1.0f,0.0f);
	SetLVertex2(&v1[1],x1,y0,z1,color,0.0f,0.0f);
	SetLVertex2(&v1[2],x1,y1,z0,color,0.0f,1.0f);
	SetLVertex2(&v1[3],x0,y1,z0,color,1.0f,1.0f);

	g_pD3DDev->CreateVertexBuffer(sizeof(v1),0,FVF_LVERTEX2,D3DPOOL_MANAGED,&g_pVB[Num],NULL);
	g_pVB[Num]->Lock(0,0,(void**)&v2,0);
	memcpy(v2,v1,sizeof(v1));
	g_pVB[Num]->Unlock();
}// Load_Board

// r{[h̕`w
// Num 	: g_pVB[] ̔ԍ (0 ` BOMB_MAX-1)
// x	: \ʒu X W
// y	: \ʒu Y W
// z	: \ʒu Z W
// tx_n	: eNX`IuWFNg̔ԍ (0 ` TEX_MAX-1)
void Set_Board(int Num,float x,float y,float z,int tx_n)
{
	g_brd_sort[g_brd_ct].flag		= 0;
	g_brd_sort[g_brd_ct].Num		= Num;
	g_brd_sort[g_brd_ct].x			= x;
	g_brd_sort[g_brd_ct].y			= y;
	g_brd_sort[g_brd_ct].z			= z;
	g_brd_sort[g_brd_ct].texture	= tx_n;

	if(g_brd_ct < BRD_MAX)
		g_brd_ct ++;
}// Set_Board

// r{[h\
void Draw_Board(int Num,float x,float y,float z,int tx_n)
{
	g_pD3DDev->SetFVF(FVF_LVERTEX2);
	g_pD3DDev->SetRenderState(D3DRS_SRCBLEND,D3DBLEND_ONE);
	g_pD3DDev->SetRenderState(D3DRS_DESTBLEND,D3DBLEND_ONE);
	
	// eNX`\
	if(tx_n != -1)
		g_pD3DDev->SetTexture(0,g_pTex[tx_n]);
	else
		g_pD3DDev->SetTexture(0,NULL);

	D3DXMATRIX matWorld,matRotateX,matRotateY,matTrans;
	// X̉]
	float len = D3DXVec2Length(&D3DXVECTOR2(x-g_look_x, z-g_look_z));
	D3DXMatrixRotationX(&matRotateX,(float)atan2(g_look_y-y,len));
	// Ỷ]
	D3DXMatrixRotationY(&matRotateY,g_roll[0]/180*PI);
	// ړ
	D3DXMatrixTranslation(&matTrans,x,y,z);
	matWorld = matRotateX * matRotateY * matTrans;
	g_pD3DDev->SetTransform(D3DTS_WORLD,&matWorld);
	
	g_pD3DDev->SetStreamSource(0,g_pVB[Num],0,sizeof(LVERTEX2));
	g_pD3DDev->DrawPrimitive(D3DPT_TRIANGLEFAN,0,2);
	
	g_pD3DDev->SetRenderState(D3DRS_SRCBLEND,D3DBLEND_SRCALPHA);
	g_pD3DDev->SetRenderState(D3DRS_DESTBLEND,D3DBLEND_INVSRCALPHA);
}// Draw_Board

// ``悷BnʂȂǂ̕`ŎgB
// Num 	: g_pVB[] ̔ԍ (0 ` BOMB_MAX-1)
// x	: \ʒu X W
// y	: \ʒu Y W
// z	: \ʒu Z W
// roll	: ]px (x) _̌Ƃ͖֌WB
// tx_n : eNX`IuWFNg̔ԍ (0 ` TEX_MAX-1)
void Draw_Rect(int Num,float x,float y,float z,float roll,int tx_n)
{
	g_pD3DDev->SetFVF(FVF_LVERTEX2);
	// eNX`\
	g_pD3DDev->SetTexture(0,g_pTex[tx_n]);
	
	D3DXMATRIX matWorld,matRotateY,matTrans;
	// Ỷ]
	D3DXMatrixRotationY(&matRotateY,roll/180*PI);
	D3DXMatrixTranslation(&matTrans,x,y,z);
	matWorld = matRotateY * matTrans;
	g_pD3DDev->SetTransform(D3DTS_WORLD,&matWorld);
	
	// eNX`W̃XP[O
	if(tx_n == 0){
		g_pD3DDev->SetTextureStageState(0, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_COUNT2);
		D3DXMATRIX matS;
		D3DXMatrixScaling(&matS, 30, 30, 0);
		g_pD3DDev->SetTransform(D3DTS_TEXTURE0, &matS);
	}
	
	g_pD3DDev->SetStreamSource(0,g_pVB[Num],0,sizeof(LVERTEX2));
	g_pD3DDev->DrawPrimitive(D3DPT_TRIANGLEFAN,0,2);
	
	// eNX`W̃XP[O
	if(tx_n == 0){
		g_pD3DDev->SetTextureStageState(0, D3DTSS_TEXTURETRANSFORMFLAGS, D3DTTFF_DISABLE);
	}
}// Draw_Rect

// ̕`w
// x	: \ʒu X W
// y	: \ʒu Y W
// z	: \ʒu Z W
void Set_Bomb(float x,float y,float z)
{
	for(int i=0;i<BOMB_MAX;i++){
		if(g_bomb_flag[i] == 0){
			g_bomb_flag[i]     = 1;
			g_bomb_data[i].x = x;
			g_bomb_data[i].y = y;
			g_bomb_data[i].z = z;
			break;
		}
	}
}// Set_Bomb

// ̃f[^Zbg
void Set_Bomb2(int Num,float x,float y,float z)
{
	g_brd_sort[g_brd_ct].flag	= 1;
	g_brd_sort[g_brd_ct].Num	= Num;
	g_brd_sort[g_brd_ct].x		= x;
	g_brd_sort[g_brd_ct].y		= y;
	g_brd_sort[g_brd_ct].z		= z;
	
	if(g_brd_ct < BRD_MAX)
		g_brd_ct ++;
}// Set_Bomb2

// r{[hɃ\[gĕ`
void Draw_All()
{
	int i;
	
	// \锚\[gɃZbg
	for(i=0;i<BOMB_MAX;i++){
		if(g_bomb_flag[i] != 0)
			Set_Bomb2(i,g_bomb_data[i].x,g_bomb_data[i].y,g_bomb_data[i].z);
	}
	
	Sort();
	
	for(i=0;i<g_brd_ct;i++){
		if(g_brd_sort[g_order[i]].flag == 0){
			// r{[h̕`
			Draw_Board(g_brd_sort[g_order[i]].Num,g_brd_sort[g_order[i]].x,g_brd_sort[g_order[i]].y,g_brd_sort[g_order[i]].z,g_brd_sort[g_order[i]].texture);
		}
		else if(g_brd_sort[g_order[i]].flag == 1){
			// ̕`
			Draw_Bomb(g_brd_sort[g_order[i]].Num,g_brd_sort[g_order[i]].x,g_brd_sort[g_order[i]].y,g_brd_sort[g_order[i]].z);
		}
	}
	
	DELETE2(g_order);
	g_brd_ct = 0;
}// Draw_All

//@r{[h_牓ɕёւ
void Sort()
{
	int 	ct,h,i;
	float	sort_max;
	float	*dist;
	
	g_order = new int[g_brd_ct];
	dist    = new float[g_brd_ct];
	
	for(i=0;i<g_brd_ct;i++){
		dist[i] = (float)sqrt((g_brd_sort[i].x-g_look_x)*(g_brd_sort[i].x-g_look_x)
				+ (g_brd_sort[i].y-g_look_y)*(g_brd_sort[i].y-g_look_y)
				+ (g_brd_sort[i].z-g_look_z)*(g_brd_sort[i].z-g_look_z));
	}
	
	sort_max = 0;
	ct = 0;
	while(sort_max != -1.0f){
		sort_max = -1.0f;
		for(i=0;i<g_brd_ct;i++){
			if(sort_max < dist[i]){
				sort_max = dist[i];
				h = i;
			}
		}
		if(sort_max >= 0){
			dist[h] = - 1.0f;
			g_order[ct] = h;
			ct ++;
		}
	}
	
	DELETE2(dist);
}// Sort

// ̕`
void Draw_Bomb(int Num,float x,float y,float z)
{
	D3DCOLOR		color;
	float			x2,y2,z2,tu,tv;
	LVERTEX2 		v[4];
	int 			q;
	float			b_size[4];
	unsigned int	b_c;
	static int		b_x[BOMB_MAX],b_y;
	static int		b_flag[BOMB_MAX][4];
	static int		b_count[BOMB_MAX][4];
	static float	b_pos_x[BOMB_MAX][4],b_pos_y[BOMB_MAX][4];
	
	g_pD3DDev->SetFVF(FVF_LVERTEX2);
	// [hsݒ
	D3DXMATRIX matWorld,matRotateX,matRotateY,matTrans;
	// ̃tB[ḧʒu
	D3DXMatrixTranslation(&matTrans,x,y,z);
	// X̉]
	float len = D3DXVec2Length(&D3DXVECTOR2(x-g_look_x, z-g_look_z));
	D3DXMatrixRotationX(&matRotateX,(float)atan2(g_look_y-y,len));
	// Ỷ]
	D3DXMatrixRotationY(&matRotateY,g_roll[0]/180*PI);
	matWorld = matRotateX * matRotateY * matTrans;
	g_pD3DDev->SetTransform(D3DTS_WORLD,&matWorld);
	
	// At@ufBO̐ݒ
	g_pD3DDev->SetRenderState(D3DRS_SRCBLEND,D3DBLEND_ONE);
	g_pD3DDev->SetRenderState(D3DRS_DESTBLEND,D3DBLEND_ONE);
	
	if(g_bomb_flag[Num] == 1){
		b_flag[Num][0] = 1;
		b_flag[Num][1] = 1;
	}
	else if(g_bomb_flag[Num] == 3){
		b_flag[Num][2] = 1;
	}
	else if(g_bomb_flag[Num] == 4){
		b_flag[Num][3] = 1;
	}
	
	for(q=0;q<4;q++){
		if(b_flag[Num][q] == 1){
			if(b_count[Num][q] == 0){
				 b_x[Num] = RandTo(2) ? 1:-1;
				 b_y = RandTo(2) ? 1:-1;
				 b_pos_x[Num][q] = RandTo(10) * b_x[Num] / 900.0f;	// ̂wW̏l
				 b_pos_y[Num][q] = RandTo(10) * b_y / 900.0f - 0.04f;// ̂xW̏l
			}
			
			if(b_count[Num][q] <= 6){
				
				b_count[Num][q] ++;
				
				b_c = 255 - 5 * b_count[Num][q] * b_count[Num][q];
				
				color = D3DCOLOR_XRGB(b_c,b_c,b_c);
				//@̂wẄړ
				b_pos_x[Num][q] += (float)b_x[Num] / 100.0f * 0.7f;
				//@̂xẄړ
				b_pos_y[Num][q] += 0.0005f * (50 - b_count[Num][q] * b_count[Num][q]);
				//@̑傫
				b_size[q] = 0.08f * (1.1f + 0.15f * b_count[Num][q]);
				
				x2 = -b_size[q] + b_pos_x[Num][q];
				y2 = -b_size[q] + b_pos_y[Num][q];
				z2 = -q * 0.001f;
				tu = 0.0f;
				tv = 0.0f;
				SetLVertex2(&v[0],x2,y2,z2,color,tu,tv);
				
				x2 = -b_size[q] + b_pos_x[Num][q];
				y2 =  b_size[q] + b_pos_y[Num][q];
				z2 = -q * 0.001f;
				tu = 1.0f;
				tv = 0.0f;
				SetLVertex2(&v[1],x2,y2,z2,color,tu,tv);
				
				x2 = b_size[q] + b_pos_x[Num][q];
				y2 = b_size[q] + b_pos_y[Num][q];
				z2 = -q * 0.001f;
				tu = 1.0f;
				tv = 1.0f;
				SetLVertex2(&v[2],x2,y2,z2,color,tu,tv);
				
				x2 =  b_size[q] + b_pos_x[Num][q];
				y2 = -b_size[q] + b_pos_y[Num][q];
				z2 = -q * 0.001f;
				tu = 0.0f;
				tv = 1.0f;
				SetLVertex2(&v[3],x2,y2,z2,color,tu,tv);
				
				// eNX`ݒ
				if(q == 0){
					g_pD3DDev->SetTexture(0,g_pTex[2]);
				}
				else if(q == 1 || q == 2){
					g_pD3DDev->SetTexture(0,g_pTex[3]);
				}
				else if(q == 3){
					g_pD3DDev->SetTexture(0,g_pTex[4]);
				}
				// eʂ`
				g_pD3DDev->DrawPrimitiveUP(D3DPT_TRIANGLEFAN,2,v,sizeof(LVERTEX2));
			}
			else{
				b_flag[Num][q] = 0;
				b_count[Num][q] = 0;
			}
		}
	}
	
	if(g_bomb_flag[Num] != 0){
		if(b_flag[Num][3] == 0 && g_bomb_flag[Num] >= 4)
			g_bomb_flag[Num] = 0;
		else
			g_bomb_flag[Num] ++;
	}
	
	// At@ufBO̐ݒ
	g_pD3DDev->SetRenderState(D3DRS_SRCBLEND,D3DBLEND_SRCALPHA);
	g_pD3DDev->SetRenderState(D3DRS_DESTBLEND,D3DBLEND_INVSRCALPHA);
}// Draw_Bomb

// CtQ[W̕`
void Draw_LifeGage()
{
	int i;
	
	// XvCg̕`
	g_pSpr->Begin();
	g_pSpr->Draw(g_pTex[13], NULL, &D3DXVECTOR2((float)WIDTH,40.0f), NULL, 0.0f, NULL, D3DCOLOR_ARGB(150,255,255,255));
	g_pSpr->Draw(g_pTex[13], NULL, &D3DXVECTOR2(111.0f,16.0f), NULL, 0.0f, &D3DXVECTOR2(60.0f,10.0f), D3DCOLOR_ARGB(255,255,255,255));
	g_pSpr->Draw(g_pTex[13], NULL, &D3DXVECTOR2(111.0f,16.0f), NULL, 0.0f, &D3DXVECTOR2(WIDTH-150.0f,10.0f), D3DCOLOR_ARGB(255,255,255,255));
	if(g_life[0] > 0)
		g_pSpr->Draw(g_pTex[9], NULL, NULL, NULL, 0.0f, &D3DXVECTOR2(165.0f-(100.0f-10.0f*(g_life[0]/10-1)),10.0f), D3DCOLOR_ARGB(255,255,255,255));
	if(g_life[0] > 4)
		g_pSpr->Draw(g_pTex[10], NULL, NULL, NULL, 0.0f, &D3DXVECTOR2(60.0f,10.0f), D3DCOLOR_ARGB(255,255,255,255));
	for(i=1;i<g_life[0]/10-1;i++)
		g_pSpr->Draw(g_pTex[10], NULL, NULL, NULL, 0.0f, &D3DXVECTOR2(60.0f+10.0f*i,10.0f), D3DCOLOR_ARGB(255,255,255,255));
	if(g_life[1] > 0)
		g_pSpr->Draw(g_pTex[9], NULL, NULL, NULL, 0.0f, &D3DXVECTOR2(WIDTH-45.0f-(100.0f-10.0f*(g_life[1]/10-1)),10.0f), D3DCOLOR_ARGB(255,255,255,255));
	if(g_life[1] > 4)
		g_pSpr->Draw(g_pTex[10], NULL, NULL, NULL, 0.0f, &D3DXVECTOR2(WIDTH-150.0f,10.0f), D3DCOLOR_ARGB(255,255,255,255));
	for(i=1;i<g_life[1]/10-1;i++)
		g_pSpr->Draw(g_pTex[10], NULL, NULL, NULL, 0.0f, &D3DXVECTOR2(WIDTH-150.0f+10.0f*i,10.0f), D3DCOLOR_ARGB(255,255,255,255));
	g_pSpr->End();
	// ̕`
	RECT rc;
	SetRect(&rc, 20, 10, 60, 60);
	g_pFont->DrawText("@", -1, &rc, DT_CENTER, D3DCOLOR_ARGB(255,255,255,255));
	SetRect(&rc, WIDTH-200, 10, WIDTH-140, 60);
	g_pFont->DrawText("G@", -1, &rc, DT_CENTER, D3DCOLOR_ARGB(255,255,255,255));
	if(g_status[0] == 3 || g_status[1] == 3){
		SetRect(&rc, 0, 10, WIDTH, 50);
		g_pFont->DrawText("[SPACE]F^Cg֖߂", -1, &rc, DT_CENTER, D3DCOLOR_ARGB(255,255,255,0));
	}
}// Draw_LifeGage

// Q[I[o[̕\
void Draw_GameOver()
{
	static float	roll = 0;
	
	if(g_mt_ct[0][1] == 13){
		D3DXMATRIX		matWorld,matT1,matT2,matRY,matS;
		
		g_pD3DDev->SetTexture(0, g_pTex[15]);
		g_pD3DDev->SetRenderState(D3DRS_SRCBLEND,D3DBLEND_ONE);
		g_pD3DDev->SetRenderState(D3DRS_DESTBLEND,D3DBLEND_ONE);
		g_pD3DDev->SetFVF(D3DFVF_XYZ);	// _tH[}bg̐ݒ
		g_pD3DDev->SetRenderState(D3DRS_LIGHTING, FALSE);
		D3DXMatrixScaling(&matS, 0.07f, 0.07f, 0.07f);
		D3DXMatrixTranslation(&matT1,-0.15f,0,0);
		D3DXMatrixRotationY(&matRY,roll/180*PI);
		D3DXMatrixTranslation(&matT2,g_pos_x[0],0.1f,g_pos_z[0]);
		matWorld = matS * matT1 * matRY * matT2;
		g_pD3DDev->SetTransform(D3DTS_WORLD,&matWorld);	// _W̍sϊ
		g_pMeshText->DrawSubset(0);
		roll += 5;
		g_pD3DDev->SetRenderState(D3DRS_SRCBLEND,D3DBLEND_SRCALPHA);
		g_pD3DDev->SetRenderState(D3DRS_DESTBLEND,D3DBLEND_INVSRCALPHA);
	}
}// Draw_GameOver

// 3DbV̍쐬
void Create_3DTextMesh()
{
	LPD3DXMESH	pMeshNew = NULL;
	HDC 		hDC = CreateCompatibleDC( NULL );
	HFONT		hFont;
	HFONT		hFontOld;
	LOGFONT 	lf;
	
	ZeroMemory(&lf, sizeof(lf));
	lf.lfPitchAndFamily = FIXED_PITCH;
	lf.lfCharSet = SHIFTJIS_CHARSET;
	lf.lfWeight = FW_BOLD;
	lf.lfStrikeOut = 1;
	hFont = CreateFontIndirect(&lf);
	hFontOld = (HFONT)SelectObject(hDC, hFont); 
	D3DXCreateText(g_pD3DDev, hDC, "GAME OVER", 
					0.001f, 0.2f, &g_pMeshText, NULL, NULL);
	SelectObject(hDC, hFontOld);
	DeleteObject(hFont);
	DeleteDC(hDC);
}// Create_3DTextMesh

// ^Cg̕\
void Draw_Title()
{
	g_pD3DDev->Clear(0,NULL,D3DCLEAR_TARGET,D3DCOLOR_XRGB(0,0,0),0,0);
	if(SUCCEEDED(g_pD3DDev->BeginScene()))
	{
		// XvCg̕`
		g_pSpr->Draw(g_pTex[1], NULL, &D3DXVECTOR2(340.0f/256,1), NULL, 0.0f,
				&D3DXVECTOR2(((float)WIDTH-340)/2,80),
				D3DCOLOR_ARGB(255,255,255,255));
		// ̕`
		RECT rc;
		SetRect(&rc, 0, 40, WIDTH, 100);
		g_pFont->DrawText("DirectX9 Sample Game", -1, &rc, DT_CENTER, D3DCOLOR_ARGB(255,255,128,0));
		SetRect(&rc, 0, 350, WIDTH, HEIGHT);
		g_pFont->DrawText("@[SPACE]FX^[g@[ESC]FI@@@@\n\n[]FOi@[]Fށ@[]F\n\n[]FE@[Z]F@[X]Fe@@@", -1, &rc, DT_CENTER, D3DCOLOR_ARGB(255,255,255,255));
		
		g_pD3DDev->EndScene();
	}
	g_pD3DDev->Present(NULL,NULL,NULL,NULL);
	
	if(g_pD3DDev->TestCooperativeLevel() == D3DERR_DEVICENOTRESET){
		g_pD3DDev->Reset(&g_d3dpp);
		InitGeometry();
		Draw_Title();
	}
}// Draw_Title

// 莞ԌoߌA^Cg֖߂
void Return_Title()
{
	if(g_status[0] == 3 || g_status[1] == 3){
		if(g_title_ct > 300){
			Init_Global();
			StopBGM();
			return;
		}
		g_title_ct ++;
	}
}// Return_Title

// G@̉̈ʒu
D3DXVECTOR3 Enemy_SoundPos()
{
	D3DXMATRIX	mat;
	D3DXVECTOR3 vs1(g_pos_x[1]-g_pos_x[0], 0, g_pos_z[1]-g_pos_z[0]), e_snd;
	D3DXMatrixRotationY(&mat, -g_roll[0]*PI/180);
	D3DXVec3TransformCoord(&e_snd, &vs1, &mat);
	return e_snd;
}// Enemy_SoundPos

// L[
void Get_Key()
{
	if(g_status[0] == 3){
		return;
	}
	
	bool flag_walk = false;
	
	// []L[Ă
	if((GetAsyncKeyState(VK_LEFT) & 0x8000) || (g_flag_PressX < 15)){
		Left();
		flag_walk = true;
	}// []L[Ă
	else if((GetAsyncKeyState(VK_RIGHT) & 0x8000) || (g_flag_PressX > 15)){
		Right();
		flag_walk = true;
	}
	// []L[Ă
	if((GetAsyncKeyState(VK_UP) & 0x8000) || (g_flag_PressY < 15)){
		if(g_status[0] == 1)
			Up(0,1);
		flag_walk = true;
	}// []L[Ă
	else if((GetAsyncKeyState(VK_DOWN) & 0x8000) || (g_flag_PressY > 15)){
		if(g_status[0] == 1)
			Down(0,1);
		flag_walk = true;
	}
	
	if(flag_walk && g_status[0] <= 1){
		g_status[0] = 1;
	}
	else if(g_status[0] == 1){
		g_status[0] = 0;
	}
	
	// [Z]L[Ă
	if((GetAsyncKeyState('Z') & 0x8000) || g_flag_PressBttn[0]){
		Key_Z();
	}
	// [X]L[Ă
	if((GetAsyncKeyState('X') & 0x8000) || g_flag_PressBttn[1]){
		Key_X();
	}
	// [C]L[Ă
	if((GetAsyncKeyState('C') & 0x8000) || g_flag_PressBttn[2]){
		Key_C();
	}
}// Get_Key

// ɐ
void Left()
{
	g_roll[0] -= 3;
	if(g_roll[0] < 0)
		g_roll[0] = 360;
}// Left

// Eɐ
void Right()
{
	g_roll[0] += 3;
	if(g_roll[0] >= 360)
		g_roll[0] = 0;		
}// Right

// Oi
void Up(bool flagEnemy, float speed)
{
	g_pos_x[flagEnemy] += 0.02f * speed * g_vec_x[flagEnemy];
	g_pos_z[flagEnemy] += 0.02f * speed * g_vec_z[flagEnemy];
	
	if(g_pos_x[flagEnemy] < -G_SIZE || g_pos_x[flagEnemy] > G_SIZE)
		g_pos_x[flagEnemy] -= 0.02f * speed * g_vec_x[flagEnemy];
	if(g_pos_z[flagEnemy] < -G_SIZE || g_pos_z[flagEnemy] > G_SIZE)
		g_pos_z[flagEnemy] -= 0.02f * speed * g_vec_z[flagEnemy];
	// QɂԂƂ
	int		i;
	float	len;
	for(i=0;i<PL_NUM;i++){
		len = D3DXVec2Length(&D3DXVECTOR2(g_pillar_x[i]-g_pos_x[flagEnemy], g_pillar_z[i]-g_pos_z[flagEnemy]));
		if(len <= PL_SIZE){
			g_pos_x[flagEnemy] -= 0.02f * speed * g_vec_x[flagEnemy];
			g_pos_z[flagEnemy] -= 0.02f * speed * g_vec_z[flagEnemy];
			break;
		}
	}
}// Up

// 
void Down(bool flagEnemy, float speed)
{
	g_pos_x[flagEnemy] -= 0.02f * speed * g_vec_x[flagEnemy];
	g_pos_z[flagEnemy] -= 0.02f * speed * g_vec_z[flagEnemy];
	
	if(g_pos_x[flagEnemy] < -G_SIZE || g_pos_x[flagEnemy] > G_SIZE)
		g_pos_x[flagEnemy] += 0.02f * speed * g_vec_x[flagEnemy];
	if(g_pos_z[flagEnemy] < -G_SIZE || g_pos_z[flagEnemy] > G_SIZE)
		g_pos_z[flagEnemy] += 0.02f * speed * g_vec_z[flagEnemy];
	// QɂԂƂ
	int		i;
	float	len;
	for(i=0;i<PL_NUM;i++){
		len = D3DXVec2Length(&D3DXVECTOR2(g_pillar_x[i]-g_pos_x[flagEnemy], g_pillar_z[i]-g_pos_z[flagEnemy]));
		if(len <= PL_SIZE){
			g_pos_x[flagEnemy] += 0.02f * speed * g_vec_x[flagEnemy];
			g_pos_z[flagEnemy] += 0.02f * speed * g_vec_z[flagEnemy];
			break;
		}
	}
}// Down

// [Vԍij
void Mt_Walk(bool flagEnemy)
{
	g_mt_idx[flagEnemy] = g_mt_walk[g_mt_ct[flagEnemy][0]];
	if((g_mt_ct[flagEnemy][0] % 3) == 2){
		if(flagEnemy){
			D3DXVECTOR3 e_snd = Enemy_SoundPos();
			PlaySND_3D(4,e_snd.x,e_snd.z);
		}
		else{
			PlaySND_3D(4,0,0);
		}
	}
	g_mt_ct[flagEnemy][0] ++;
	if(g_mt_ct[flagEnemy][0] > 5)
		g_mt_ct[flagEnemy][0] = 0;
}// Mt_Walk

// [Vԍij
void Mt_Damage(bool flagEnemy)
{
	static int ct = 0;
	
	g_mt_idx[flagEnemy] = g_mt_damage[ct];
	ct ++;
	if(ct > 5){
		ct = 0;
		g_status[flagEnemy] = 0;
		g_mt_idx[flagEnemy] = 6;
		g_mt_ct[flagEnemy][2] = 24;
		g_mt_ct[flagEnemy][3] = 0;
		Down(flagEnemy, 0.8f);
		if(g_life[flagEnemy] <= 0){
			g_status[flagEnemy] = 3;
		}
	}
}// Mt_Damage

// [Vԍi|j
void Mt_Down(bool flagEnemy)
{
	if(g_mt_ct[flagEnemy][1] == 4 || g_mt_ct[flagEnemy][1] == 12){
		if(flagEnemy){
			D3DXVECTOR3 e_snd = Enemy_SoundPos();
			PlaySND_3D(2,e_snd.x,e_snd.z);
		}
		else{
			PlaySND_3D(2,0,0);
		}
	}
	g_mt_idx[flagEnemy] = g_mt_down[g_mt_ct[flagEnemy][1]];
	if(g_mt_ct[flagEnemy][1] < 13){
		g_mt_ct[flagEnemy][1] ++;
	}
}// Mt_Down

// [Vԍij
void Mt_Sord(bool flagEnemy)
{
	if(g_mt_ct[flagEnemy][2] == 28){
		if(flagEnemy){
			D3DXVECTOR3 e_snd = Enemy_SoundPos();
			PlaySND_3D(3,e_snd.x,e_snd.z);
		}
		else{
			PlaySND_3D(3,0,0);
		}
	}
	g_mt_idx[flagEnemy] = g_mt_ct[flagEnemy][2] ++;
	if(g_mt_ct[flagEnemy][2] > 33){
		g_mt_ct[flagEnemy][2] = 24;
		g_status[flagEnemy] = 0;
		g_mt_idx[flagEnemy] = 6;
	}
	Up(flagEnemy, 0.8f);
}// Mt_Sord

// [Vԍiej
void Mt_Gun(bool flagEnemy)
{
	g_mt_idx[flagEnemy] = g_mt_gun[g_mt_ct[flagEnemy][3]];
	g_mt_ct[flagEnemy][3] ++;
	if(g_mt_ct[flagEnemy][3] == 5){
		Throw_Ball(flagEnemy);
		if(flagEnemy){
			D3DXVECTOR3 e_snd = Enemy_SoundPos();
			PlaySND_3D(1,e_snd.x,e_snd.z);
		}
		else{
			PlaySND_3D(1,0,0);
		}
	}
	else if(g_mt_ct[flagEnemy][3] > 9){
		g_mt_ct[flagEnemy][3] = 0;
		g_status[flagEnemy] = 0;
		g_mt_idx[flagEnemy] = 6;
	}
}// Mt_Gun

// [Z]L[ꂽƂ
void Key_Z()
{
	if(g_status[0] != 2 && g_status[0] != 3){
		g_status[0] = 4;
		g_mt_ct[0][3] = 0;
	}
}// Key_Z

// [X]L[ꂽƂ
void Key_X()
{
	if(g_status[0] != 2 && g_status[0] != 3){
		g_status[0] = 5;
		g_mt_ct[0][2] = 24;
	}
}// Key_X

// [C]L[ꂽƂ
void Key_C()
{
}// Key_C

// e
void Throw_Ball(bool flagEnemy)
{
	float	ball_roll;	//@e̕
	int 	i;
	
	for(i=0;i<TAMA_NUM;i++){
		if(g_ball_ct[i] == 0){
			g_flag_throwEnemy[i] = flagEnemy;
			ball_roll = (g_roll[g_flag_throwEnemy[i]] + 10.0f)/180*PI;
			g_ball_x[i] = g_pos_x[g_flag_throwEnemy[i]] + 0.1f * (float)sin(ball_roll + 30.0f/180*PI);
			g_ball_z[i] = g_pos_z[g_flag_throwEnemy[i]] + 0.1f * (float)cos(ball_roll + 30.0f/180*PI);
			if(!g_flag_throwEnemy[i]){
				g_ball_vec_x[i] = (float)sin(ball_roll);
				g_ball_vec_z[i] = (float)cos(ball_roll);
			}
			else{
				float ball_roll2 = (g_roll[1] - 5.0f + 1.0f * (RandTo(10)-5))/180*PI;
				g_ball_vec_x[i] = (float)sin(ball_roll2);
				g_ball_vec_z[i] = (float)cos(ball_roll2);
			}
			g_ball_ct[i] = 1;
			break;
		}
	}
}// Throw_Ball

// e̕`揀
void Set_Ball()
{
	int 	i;
	
	// ^}̕`揀
	for(i=0;i<TAMA_NUM;i++){
		if(g_ball_ct[i] != 0){
			Set_Board(2,g_ball_x[i],0.17f,g_ball_z[i],5+g_flag_throwEnemy[i]);
			g_ball_x[i] += 0.1f * g_ball_vec_x[i];
			g_ball_z[i] += 0.1f * g_ball_vec_z[i];
			g_ball_ct[i] ++;
			if(g_ball_ct[i] == 20){
				g_ball_ct[i] = 0;
			}
			if(g_ball_x[i] < - G_SIZE || g_ball_x[i] > G_SIZE || g_ball_z[i] < - G_SIZE || g_ball_z[i] > G_SIZE){
				g_ball_ct[i] = 0;
			}
		}
	}
}// Set_Ball

// 0 ` max ܂ł̗Ԃ
int RandTo(int max)
{
	return (int)((float)max * rand() / (RAND_MAX + 1.0f));
}

// Oϐ̏iff[^͏j
void Init_Global()
{
	int i;
	
	for(i=0;i<BRD_MAX;i++){
		ZeroMemory(&g_brd_sort[i], sizeof(BOARD_SORT));
	}
	for(i=0;i<BOMB_MAX;i++){
		ZeroMemory(&g_brd_sort[i], sizeof(BOARD_SORT));
		g_bomb_flag[i] = 0;
	}
	for(i=0;i<2;i++){
		g_mt_idx[i]   = 0;
		g_status[i]   = 0;
		g_mt_ct[i][0] = 0;
		g_mt_ct[i][1] = 0;
		g_mt_ct[i][2] = 24;
		g_mt_ct[i][3] = 0;
		g_life[i]     = 100;
		g_pos_z[i]    = 0;
		g_vec_x[i]    = 0;
		g_vec_z[i]    = 0;
	}
	g_pos_x[0] = -0.5f;
	g_pos_x[1] = 0.5f;
	g_roll[0]  = 90;
	g_roll[1]  = 270;
	g_look_x = 0.0f;
	g_look_y = 0.0f;
	g_look_z = 0.0f;
	g_brd_ct = 0;
	g_vecEM_x = 0;
	g_vecEM_z = 0;
	g_lenEM = 0;
	for(i=0;i<TAMA_NUM;i++){
		g_flag_throwEnemy[i] = 0;
		g_ball_x[i] = 0;
		g_ball_z[i] = 0;
		g_ball_vec_x[i] = 0;
		g_ball_vec_z[i] = 0;
		g_ball_ct[i] = 0;
	}
	DELETE2(g_order);
	g_flagTitle = 1;
	g_title_ct = 0;
}// Init_Global

// t@CǂݍݑȌ
void Init_File(int idx)
{
	g_pD3DDev->SetTexture(0, NULL);
	
	//̈
	DELETE2(g_pp1[idx]);
	DELETE2(g_m1[idx].pv);
	DELETE2(g_m1[idx].pn);
	DELETE2(g_m1[idx].ptu);
	DELETE2(g_m1[idx].ptv);
	DELETE2(g_m1[idx].pf);
	ZeroMemory(&g_m1[idx], sizeof(g_m1[idx]));
	g_m1[idx].mt_ct = 0;
	g_mt_idx[idx] = 0;
	for(int i=0;i<TAMA_NUM;i++)
		g_flag_throwEnemy[i] = 0;
}// Init_File

// BDTt@C̓ǂݍ
bool Load_File_BDT(int idx, char *filename)
{
	FILE 	*file1;
	
	char 	ss[256];
	float 	ww[9];
	int		flag = 0;
	int 	vv[4],p_ct = 0,ct1 = 0,ct2 = 0,ct3 = 0,ct4 = 0;
	int		i;
	
	Init_File(idx);		// Oϐ̏
	
	if((file1=fopen(filename,"r")) == NULL){
		return 0;		
	}
	
	while(!feof(file1)){
		
		fgets(ss,256,file1);
		ss[strlen(ss)-1] = '\0';
		
		// p[c̐
		if(strstr(ss,"<parts_count>") != NULL){
			flag = 1;
		}
		if(strstr(ss,"</parts_count>") != NULL){
			flag = 0;
		}
		if(flag == 1 && strstr(ss,"<parts_count>") == NULL){
			sscanf(ss,"%d",&g_m1[idx].parts_ct);
			if(g_m1[idx].parts_ct >= P_MAX){
				fclose(file1);
				return 0;
			}
			g_pp1[idx] = new PARTS [g_m1[idx].parts_ct+1];
			for(i=0;i<g_m1[idx].parts_ct;i++){
				g_pp1[idx][i].vtx_ct = 0;
				g_pp1[idx][i].face_ct = 0;
			}
		}
		
		// [V̐
		if(strstr(ss,"<motion_count>") != NULL){
			flag = 2;
		}
		if(strstr(ss,"</motion_count>") != NULL){
			flag = 0;
		}
		if(flag == 2 && strstr(ss,"<motion_count>") == NULL){
			sscanf(ss,"%d",&g_m1[idx].mt_ct);
			if(g_m1[idx].mt_ct >= M_MAX){
				fclose(file1);
				return 0;
			}
		}
		
		// IuWFNgŜ̒_W̐
		if(strstr(ss,"<total_vertex_count>") != NULL){
			flag = 4;
		}
		if(strstr(ss,"</total_vertex_count>") != NULL){
			flag = 0;
		}
		if(flag == 4 && strstr(ss,"<total_vertex_count>") == NULL){
			sscanf(ss,"%d",&g_m1[idx].t_vtx_ct);
			g_m1[idx].pv  = new D3DXVECTOR3 [g_m1[idx].t_vtx_ct];
			g_m1[idx].pn  = new D3DXVECTOR3 [g_m1[idx].t_vtx_ct];
			g_m1[idx].ptu = new float       [g_m1[idx].t_vtx_ct];
			g_m1[idx].ptv = new float       [g_m1[idx].t_vtx_ct];
			ZeroMemory(g_m1[idx].ptu, g_m1[idx].t_vtx_ct * sizeof(float));
			ZeroMemory(g_m1[idx].ptv, g_m1[idx].t_vtx_ct * sizeof(float));
		}
		
		// IuWFNgŜ̖ʂ̐
		if(strstr(ss,"<total_face_count>") != NULL){
			flag = 5;
		}
		if(strstr(ss,"</total_face_count>") != NULL){
			flag = 0;
		}
		if(flag == 5 && strstr(ss,"<total_face_count>") == NULL){
			sscanf(ss,"%d",&g_m1[idx].t_face_ct);
			g_m1[idx].pf = new int [g_m1[idx].t_face_ct][4];
		}
		
		// ǂݍ񂾃p[c̐
		if(strstr(ss,"</polygon_mesh>") != NULL){
			p_ct ++;
		}
		
		// p[cƂ̒_W
		if(strstr(ss,"<vertices>") != NULL){
			flag = 12;
		}
		if(strstr(ss,"</vertices>") != NULL){
			flag = 0;
			g_pp1[idx][p_ct + 1].vtx_ct = ct1;
		}
		if(flag == 12 && strstr(ss,"<vertices>") == NULL){
			sscanf(ss,"%f %f %f %f %f %f %f %f",&ww[0],&ww[1],&ww[2],&ww[3],&ww[4],&ww[5],&ww[6],&ww[7]);
			g_m1[idx].pv[ct1].x = ww[0];
			g_m1[idx].pv[ct1].y = ww[1];
			g_m1[idx].pv[ct1].z = ww[2];
			g_m1[idx].pn[ct1].x = ww[3];
			g_m1[idx].pn[ct1].y = ww[4];
			g_m1[idx].pn[ct1].z = ww[5];
			g_m1[idx].ptu[ct1]  = ww[6];
			g_m1[idx].ptv[ct1]  = ww[7];
			ct1 ++;
		}
		
		// p[cƂ̖ʂ\钸_W̔ԍ
		if(strstr(ss,"<faces>") != NULL){
			flag = 13;
		}
		if(strstr(ss,"</faces>") != NULL){
			flag = 0;
			g_pp1[idx][p_ct + 1].face_ct = ct2;
		}
		if(flag == 13 && strstr(ss,"<faces>") == NULL){
			sscanf(ss,"%d %d %d %d",&vv[0],&vv[1],&vv[2],&vv[3]);
			g_m1[idx].pf[ct2][0] = vv[0];
			g_m1[idx].pf[ct2][1] = vv[1];
			g_m1[idx].pf[ct2][2] = vv[2];
			g_m1[idx].pf[ct2][3] = vv[3];
			ct2 ++;
		}
		
		// ֐߂̉]px
		if(strstr(ss,"<joint>") != NULL){
			flag = 14;
		}
		if(strstr(ss,"</joint>") != NULL){
			flag = 0;
			ct3 = 0;
			ct4 ++;
		}
		if(flag == 14 && strstr(ss,"<joint>") == NULL){
			sscanf(ss,"%f %f %f %f %f %f %f %f %f",&ww[0],&ww[1],&ww[2],&ww[3],&ww[4],&ww[5],&ww[6],&ww[7],&ww[8]);
			Set_Matrix(idx,ct3,ct4,ww);
			ct3 ++;
		}
	}
	
	fclose(file1);
	
	if(!g_m1[idx].parts_ct || !g_m1[idx].t_vtx_ct || !g_m1[idx].t_face_ct)
		return 0;
	
	return 1;
}// Load_File_BDT

// ㏈
void Cleanup()
{
	int i;
	
	joyReleaseCapture(JOYSTICKID1);
	//̈
	for(i=0;i<2;i++){
		DELETE2(g_pp1[i]);
		DELETE2(g_m1[i].pv);
		DELETE2(g_m1[i].pn);
		DELETE2(g_m1[i].ptu);
		DELETE2(g_m1[i].ptv);
		DELETE2(g_m1[i].pf);
	}
	// Direct3DC^[tF[X
	for(i=0;i<TEX_MAX;i++){
		RELEASE(g_pTex[i]);
	}
	for(i=0;i<BRD_MAX;i++){
		RELEASE(g_pVB[i]);
	}
	RELEASE(g_pSpr);
	RELEASE(g_pFont);
	RELEASE(g_pMeshText);
	RELEASE(g_pD3DDev);
	RELEASE(g_pD3D);
	Music_Term();
}// Cleanup
